#include <uuid/uuid.h>

#include <postgres.h>
#include <fmgr.h>

#include <utils/timestamp.h>
#include <utils/inet.h>

#include <time.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>


typedef unsigned char * uuid_p;




PG_FUNCTION_INFO_V1(util_uuid_timestamp);
Datum util_uuid_timestamp(PG_FUNCTION_ARGS)
{
	struct tm* t;
	Timestamp result;

	uuid_p p = (uuid_p) PG_GETARG_POINTER(0);

	/* if p does not point to a time-base uuid return null*/
	if (uuid_variant(p) != UUID_VARIANT_DCE ||
	    uuid_type(p) != UUID_TYPE_DCE_TIME)
	{
		PG_RETURN_NULL();
	}

#if 0
	{
	   struct timeval tv;
	   struct tm tm;
	   TimestampTz result;
	   fsec_t fsec;
	   uuid_time(p, &tv);
	   gmtime_r(&(tv.tv_sec), &tm);
	   -- tm.tm_mon;
	   tm.tm_year += 1900;
	   fsec = tv.tv_usec;
	   tm2timestamp((struct pg_tm*) &tm, fsec, NULL, &result);
	   PG_RETURN_TIMESTAMPTZ(result);
	}
#else
	PG_RETURN_TIMESTAMP(time_t_to_timestamptz(uuid_time(p, NULL)));
#endif
}

PG_FUNCTION_INFO_V1(util_uuid_macaddr);
Datum util_uuid_macaddr(PG_FUNCTION_ARGS)
{
	uuid_p p = (uuid_p) PG_GETARG_POINTER(0);

	macaddr* mdp = (macaddr*)palloc(sizeof(macaddr));

	if (uuid_variant(p) != UUID_VARIANT_DCE ||
	    uuid_type(p) != UUID_TYPE_DCE_TIME)
	{
		PG_RETURN_NULL();
	}

	memcpy(mdp, p+10, 6);

	PG_RETURN_MACADDR_P(mdp);
}
