---------------------------------------------------------------------------
--
-- FILE
--    pguuid.sql
--
-- DESCRIPTION
--    Postgres-side function definitions etc.
--
-- Copyright (c) 2002-2003, Mike Wang <xylophone2001@hotmail.com>
-- Copyright (c) 2009, David Lee Lambert <davidl@lmert.com>
--
---------------------------------------------------------------------------
--
-- $Id: pguuid.sql 284 2009-02-08 04:00:43Z davidl $
-- 
---------------------------------------------------------------------------
SET autocommit TO 'on';

-- Register 'uuid' create functions
CREATE OR REPLACE FUNCTION newid_time()
RETURNS uuid
VOLATILE
STRICT
AS '$libdir/pguuid'
LANGUAGE 'C';

-- for compatibility with OSSP-uuid
CREATE FUNCTION uuid_generate_v1() 
RETURNS uuid AS 'SELECT newid_time()' 
VOLATILE STRICT LANGUAGE SQL;

CREATE OR REPLACE FUNCTION newid_random()
RETURNS uuid
VOLATILE
STRICT
AS '$libdir/pguuid'
LANGUAGE 'C';

CREATE FUNCTION uuid_generate_v4() 
RETURNS uuid AS 'SELECT newid_random()' 
VOLATILE STRICT LANGUAGE SQL;

CREATE OR REPLACE FUNCTION newid_nil()
RETURNS uuid
IMMUTABLE
STRICT
AS '$libdir/pguuid'
LANGUAGE 'C';

CREATE OR REPLACE FUNCTION newid() 
RETURNS uuid
VOLATILE
STRICT
AS '$libdir/pguuid', 'newid_default'
LANGUAGE 'C';


-- Register util function
CREATE OR REPLACE FUNCTION uuid_type(uuid)
RETURNS int2
STRICT
AS '$libdir/pguuid', 'util_uuid_type'
LANGUAGE 'C';

CREATE OR REPLACE FUNCTION uuid_variant(uuid)
RETURNS int2
STRICT
AS '$libdir/pguuid', 'util_uuid_variant'
LANGUAGE 'C';

CREATE OR REPLACE FUNCTION uuid_timestamp(uuid)
RETURNS timestamptz
STRICT
AS '$libdir/pguuid', 'util_uuid_timestamp'
LANGUAGE 'C';

CREATE OR REPLACE FUNCTION uuid_macaddr(uuid)
RETURNS macaddr
STRICT
AS '$libdir/pguuid', 'util_uuid_macaddr'
LANGUAGE 'C';

--
-- eof
--
